#ifndef AKTOR_H
#define AKTOR_H

#include "MacierzGL.h"
#include "Werteks.h"

class Aktor
{
protected:
	unsigned int vao, vbo;
	unsigned int liczbaWerteksów;

private:
	void InicjujBuforWerteksów();
	void UsuńBuforWerteksów();

protected:	
	virtual unsigned int TwórzTablicęWerteksów(CWerteks*& werteksy) = 0; //obowiązki: zapełnienie tablicy werteksów, zwrócenie liczby werteksów

public:	
	Macierz4 MacierzŚwiata;
	virtual void Inicjuj(GLuint atrybutPołożenie, GLuint atrybutNormalna, GLuint atrybutKolor); //może być wywoływane w konstruktorach klas potomnych, ale nie klasy bazowej
	virtual void Rysuj();

	//materiał
	Wektor4 MateriałŚwiatłoOtoczenia;
	Wektor4 MateriałŚwiatłoRozpraszane;
	Wektor4 MateriałŚwiatłoRozbłysku;
	float MateriałWykładnikRozbłysku;
	
	Aktor();	
	virtual ~Aktor();	
};

//typedef Aktor* PAktor;

//--------------------------------------------

class AktorZBuforemIndeksów : public Aktor
{
protected:
	unsigned int liczbaIndeksów;
	unsigned int vbo_indeksy;

private:
	void InicjujBuforIndeksów();
	void UsuńBuforIndeksów();

protected:
	virtual unsigned int TwórzTablicęIndeksów(GLuint*& indeksy) = 0;

public:
	virtual void Inicjuj(GLuint atrybutPołożenie, GLuint atrybutNormalna, GLuint atrybutKolor);
	virtual void Rysuj();

	AktorZBuforemIndeksów();
	virtual ~AktorZBuforemIndeksów();
};

//--------------------------------------------

class Kwadrat : public Aktor
{
private:
	float długośćKrawędzi;
	unsigned int TwórzTablicęWerteksów(CWerteks*& werteksy);

public:
	Kwadrat(GLuint atrybutPołożenie, GLuint atrybutNormalna, GLuint atrybutKolor, float długośćKrawędzi = 2.0f);
};

class Trójkąt : public Aktor
{
private:
	float długośćPodstawy, wysokość;
	unsigned int TwórzTablicęWerteksów(CWerteks*& werteksy);

public:
	Trójkąt(GLuint atrybutPołożenie, GLuint atrybutNormalna, GLuint atrybutKolor, float długośćPodstawy = 2.0f, float wysokość = 2.0f);
};

class KwadratZBuforemIndeksów : public AktorZBuforemIndeksów
{
private:
	float długośćKrawędzi;	
	unsigned int TwórzTablicęWerteksów(CWerteks*& werteksy);
	unsigned int TwórzTablicęIndeksów(GLubyte*& indeksy);

public:
	KwadratZBuforemIndeksów(GLuint atrybutPołożenie, GLuint atrybutNormalna, GLuint atrybutKolor, float długośćKrawędzi = 2.0f);
};

//--------------------------------------------

class Prostopadłościan : public Aktor
{
private:	
	float długośćKrawędziX, długośćKrawędziY, długośćKrawędziZ;
	bool koloruj;
	unsigned int TwórzTablicęWerteksów(CWerteks*& werteksy);

public:
	void Rysuj();

	Prostopadłościan(GLuint atrybutPołożenie, GLuint atrybutNormalna, GLuint atrybutKolor, float długośćKrawędziX, float długośćKrawędziY, float długośćKrawędziZ, bool koloruj);

	static Prostopadłościan* StwórzSześcian(GLuint atrybutPołożenie, GLuint atrybutNormalna, GLuint atrybutKolor, float długośćKrawędzi, bool koloruj)
	{
		return new Prostopadłościan(atrybutPołożenie, atrybutNormalna, atrybutKolor, długośćKrawędzi, długośćKrawędzi, długośćKrawędzi, koloruj);
	}
};

#endif
